﻿namespace SelfPropelledArtilleryUnit.Entities;
/// <summary>
/// Класс-сущность "Самоходная арт. установка"
/// </summary>
public class EntitySelfPropelledArtilleryUnit : EntityPropelledArtillery
{
    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }
    /// <summary>
    /// Признак - Башня с орудием
    /// </summary>
    public bool TurretCannon { get; private set; }
    /// <summary>
    /// Признак - Залповая батарея сзади
    /// </summary>
    public bool LaunchBattery { get; private set; }
    /// <summary>
    /// Шаг перемещения артеллерийской установки
    /// </summary>
    public double Step => Speed * 100 / Weight;

    /// <summary>
    /// Инициализация полей объекта-класса EntitySelfPropelledArtilleryUnit
    /// </summary>
    /// <param name="additionalcolor">Дополнительный цвет</param>
    /// <param name="turretcannon">Башня с орудием</param>
    /// <param name="launchbattery">Залповая батарея сзади</param>
    public EntitySelfPropelledArtilleryUnit(int speed, double weight, Color bodycolor, Color additionalcolor, bool turretcannon, bool launchbattery) : base(speed, weight, bodycolor)
    {
        AdditionalColor = additionalcolor;
        TurretCannon = turretcannon;
        LaunchBattery = launchbattery;
    }
}

